;Arabf.
Graphics3D 800,600,32,2
SetBuffer BackBuffer()

AppTitle "Arabflyer"

HidePointer

hs$="highscore.txt"

If FileType(hs$)<>0
	
	h=ReadFile(hs$)
	high=ReadInt(h)
	name$=ReadString(h)
	CloseFile h
	
EndIf

f=LoadFont("ARIAL",30)
rs=LoadFont("Comic Sans MS",60,1)
f2=LoadFont("ARIAL",40,1,0,1)

mx=GraphicsWidth()/2
my=GraphicsHeight()/2

SetFont f2
Text mx,my-60,"Arab-flyer",1,1
SetFont f
Text mx,my,"Zerstre so viele Huser, wie mglich!",1,1
If high>0 Then Text mx,my+30,"Highscore: "+name$+" - "+high,1,1

Global points=0,p,spx#,spy#,spz#

Flip
Cls
WaitKey

SeedRnd 1500

Const T_P=1
Const T_H=2
Const T_G=3

Type H
	
	Field obj,h#
	
End Type

Type part
	
	Field xf#,yf#,zf#,obj,lt
	
End Type

d=128
st=CreateTexture(d,d)
SetBuffer TextureBuffer(st)
For x=1 To 20
	Plot Rnd(d),Rnd(d)
Next
sk=CreateCube()
EntityTexture sk,st
ScaleEntity sk,100,100,100
FlipMesh sk
EntityType sk,T_G
SetBuffer BackBuffer()

p=CreatePivot()
flugzeug=CreateCube(p)
fluegel=CreateCube(p)
ScaleEntity flugzeug,.5,.5,2
ScaleEntity fluegel,2,.1,.5

EntityColor flugzeug,0,0,255
EntityColor fluegel,255,0,0

cam=CreateCamera(p)
MoveEntity cam,0,2,-5
PointEntity cam,flugzeug

PositionEntity p,0,5,0

EntityType p,T_P
EntityRadius p,2,2

CreateWorld()

spx#=0
spy#=0
spz#=0

Collisions T_P,T_H,2,2
Collisions T_P,T_G,2,2

c=50

MoveMouse mx,my
FlushMouse

While (Not KeyHit(1)) And c>0
	
	TranslateEntity p,spx#,spy#,spz#
	spy#=spy#-.05/(1+Sqr(spx#^2+spy#^2+spz#^2)*5)
	
	tp#=tp#-MouseYSpeed()*.3
	y#=y#-MouseXSpeed()*.3
	
	RotateEntity p,-tp#,y#,0
	
	s=KeyDown(200) Or KeyDown(17)
	
	spx#=(spx#)*.95+s*Sin(y#+180)*Cos(tp#)*.05
	spy#=(spy#)*.95+s*Sin(tp#)*.05
	spz#=(spz#)*.95+s*Cos(y#)*Cos(tp#)*.05
	
	If EntityCollided(p,T_G) And spy#<0 Then spy#=0
	
	If EntityCollided(p,T_H)
		
		r=CollisionEntity(p,1)
		
		For t.H=Each H
			
			If t\obj=r
				
				Explo(r)
				FreeEntity t\obj
				Delete t
				
			EndIf
			
		Next
		
	EndIf
	
	UpdateWorld
	RenderWorld
	
	MoveMouse mx,my
	
	Update
	
	c=0
	For t.H=Each H
		
		c=c+1
		
	Next
	
	Text mx,my/3-15,"Huser: "+(50-c)+"/50",1,1
	Text mx,my/3+15,"Punkte: "+points,1,1
	
	Flip
	
Wend

FlushKeys
SetFont rs

If points>0
	
	s=MilliSecs()
	
	While MilliSecs()-s<3000
		
		Cls
		
		Text mx,my,"Sie haben "+points+" Punkte erreicht!",1,1
		
		Flip
		
	Wend
	
	Cls
	If points>high
		
		Text mx,my,"Neue Highscore!",1,1
		Locate mx/2,my+30
		n$=Input$("Name:   ")
		
		high=WriteFile(hs$)
		WriteInt high,points
		WriteString high,n$
		
	EndIf
	
EndIf

End

Function CreateWorld()
	
	gtex=CreateTexture(32,32)
	SetBuffer TextureBuffer(gtex)
	For x=0 To 31
		For y=0 To 31
			g=Rnd(255)
			Color 0,g,0
			Plot x,y
		Next
	Next
	
	ground=CreateCube()
	ScaleEntity ground,100,.1,100
	EntityType ground,T_G
	
	s#=.01
	
	EntityTexture ground,gtex
	ScaleTexture gtex,s#,s#
	
	Color 255,255,255
	ht=CreateTexture(32,32)
	SetBuffer TextureBuffer(ht)
	For x=0 To 31
		For y=0 To 31
			If y-x Then Plot x,y
		Next
	Next
	
	For x=1 To 50
		
		r.H=New H
		r\obj=CreateCube()
		r\h#=Rnd(10)+2
		ScaleEntity r\obj,1,r\h#,1
		PositionEntity r\obj,Rnd(100)-50,r\h#,Rnd(100)-50
		EntityType r\obj,T_H
		EntityTexture r\obj,ht
		
	Next
	
	SetBuffer BackBuffer()
	
End Function

Function Explo(obj)
	
	points=points+100+EntityY#(p)*Sqr(spx#^2+spy#^2+spz#^2)*10
	
	For x=1 To 100
		
		r.part=New part
		r\obj=CreateCube()
		ScaleEntity r\obj,.1,.1,.1
		PositionEntity r\obj,EntityX#(obj),EntityY#(obj),EntityZ#(obj)
		r\xf#=Rnd(10)-5
		r\yf#=Rnd(10)-5
		r\zf#=Rnd(10)-5
		r\lt=100
		EntityColor r\obj,255,0,0
		
	Next
	
End Function

Function Update()
	
	For r.part=Each part
		
		r\xf#=r\xf#*.9
		r\yf#=r\yf#-.1
		r\zf#=r\zf#*.9
		MoveEntity r\obj,r\xf#,r\yf#,r\zf#
		TurnEntity r\obj,Rnd(1),Rnd(1),Rnd(1)
		r\lt=r\lt-1
		EntityAlpha r\obj,r\lt/100.
		If r\lt=0 Then FreeEntity r\obj:Delete r
		
	Next
	
End Function